( function( $ ) {
    "use strict";
        var $scope = $('#holdy-admin-generator');
        var placeholderURL = function () {
        var url = $scope.find('.holdy-list-wrapper').attr('data-url');
        var size = $scope.find('.holdy-list-wrapper').attr('data-size');
        var width = $scope.find('input[name="holdy_width"]').val();
        var height = $scope.find('input[name="holdy_height"]').val();
        var format = $scope.find('select[name="holdy_format"] option:selected').val();
        var fontFamily = $scope.find('select[name="holdy_font_family"] option:selected').val();
        var fontSize = $scope.find('input[name="holdy_font_size"]').val();
        var fontColor = $scope.find('input[name="holdy_font_color"]').val();
        var bgColor = $scope.find('input[name="holdy_background"]').val();
        var text = $scope.find('textarea[name="holdy_text"]').val();
        var align = $scope.find('select[name="holdy_align"] option:selected').val();
        var strokeColor = $scope.find('input[name="holdy_stroke_color"]').val();
        var strokeSize = $scope.find('input[name="holdy_stroke_size"]').val();

        if (width != '' && height != '') {
            size = width + 'x' + height;
        } else if (width != '') {
            size = width;
        } else if (height != '') {
            size = height;
        }

        url = url + size + '.' + format;

        if (fontFamily != '' || fontSize != '' || fontColor != '' || bgColor != '' || text != '' || align != 'center-center' || strokeColor != '') {
            url = url + '?';
            if (text != '') {
                text = text.replace(/(\r\n|\r|\n)/g, '\$5Cn');
                url = url + 'text=' + text.replace(/ /g, '+') + '&';
            }
            if (fontFamily != '') {
                url = url + 'font=' + fontFamily + '&';
            }
            if (fontSize != '') {
                url = url + 'fontsize=' + fontSize + '&';
            }
            if (fontColor != '') {
                url = url + 'foreground=' + fontColor.replace('#', '') + '&';
            }
            if (bgColor != '') {
                url = url + 'background=' + bgColor.replace('#', '') + '&';
            }
            if (align != 'center-center') {
                url = url + 'align=' + align + '&';
            }
            if (strokeColor != '') {
                url = url + 'strokecolor=' + strokeColor.replace('#', '') + '&';
                if (strokeSize != '') {
                    url = url + 'strokesize=' + strokeSize + '&';
                }
            }
            url = url.slice(0,-1);
        }

        $scope.find('input[name="holdy_placeholder_url"]').val(url);
        $scope.find('.holdy-placeholder-img').attr('src', url);
    };

    placeholderURL();

    // Colorpicker
    $scope.find('.holdy-colorpicker').spectrum({
        type: "component",
        showButtons: false,
        showAlpha: false,
        allowEmpty: true,
        showInput: true,
        preferredFormat: "hex",
        change: function() {
            placeholderURL();
        }
    });

    // Numeric Validation
    $scope.find('.holdy-numeric').on('keypress', function (e) {
        if (String.fromCharCode(e.keyCode).match(/[^0-9]/g)) return false;
    });

    // Max-Min Validation
    $scope.find('.holdy-numeric').on('change', function () {
        var max = parseInt($(this).attr('max'));
        var min = parseInt($(this).attr('min'));
        if ($(this).val() > max) {
            $(this).val(max);
        } else if ($(this).val() < min) {
            $(this).val(min);
        }       
    }); 

    // Refresh image after a the value changed
    $scope.find('.holdy-input-text').on('change', function () {
        placeholderURL();
    });

    $scope.find('.holdy-textarea').on('change', function () {
        placeholderURL();
    });

    $scope.find('.holdy-select').on('change', function () {
        placeholderURL();   
    });

    $scope.find('input[name="holdy_placeholder_url"]').on('focus', function (e) {
        var copyText = $(this)[0];
        copyText.select();
        copyText.setSelectionRange(0, 99999);
    });

    // Copy to clipboard button
    $scope.find('button[name="holdy_copy_url"]').on('click', function (e) {
        var input = $(this);
        var copyText = $scope.find('input[name="holdy_placeholder_url"]')[0];
        copyText.select();
        copyText.setSelectionRange(0, 99999);
        navigator.clipboard.writeText(copyText.value);
        input.html(input.attr('data-copied'));
        setTimeout(function(){
            input.html(input.attr('data-text'));
        }, 2000); 
    });    
    
    // View image
    $scope.find('button[name="holdy_img_view"]').on('click', function (e) {
        var newTab = $scope.find('input[name="holdy_placeholder_url"]').val();
        window.open(newTab, '_blank').focus();
    }); 
    
    // Download image
    $scope.find('button[name="holdy_img_download"]').on('click', function (e) {
        var size = $scope.find('.holdy-list-wrapper').attr('data-size');
        var width = $scope.find('input[name="holdy_width"]').val();
        var height = $scope.find('input[name="holdy_height"]').val();
        if (width != '' && height != '') {
            size = width + 'x' + height;
        } else if (width != '') {
            size = width;
        } else if (height != '') {
            size = height;
        }
        var url = $scope.find('input[name="holdy_placeholder_url"]').val();
        var format = $scope.find('select[name="holdy_format"] option:selected').val();
        var link = document.createElement("a");
        link.download = size + '.' + format;
        link.href = url;
        link.click();
        link.remove();
    }); 

    // Save image
    $scope.find('button[name="holdy_img_save"]').on('click', function (e) {
        var btn = $(this);
        btn.html(btn.attr('data-saving'));
        var url = $scope.find('input[name="holdy_placeholder_url"]').val();
        var ajaxUrl = btn.attr('data-ajax');
        var nonce = btn.attr('data-nonce');
        var format = $scope.find('select[name="holdy_format"] option:selected').val();
        var size = $scope.find('.holdy-list-wrapper').attr('data-size');
        var width = $scope.find('input[name="holdy_width"]').val();
        var height = $scope.find('input[name="holdy_height"]').val();
        if (width != '' && height != '') {
            size = width + 'x' + height;
        } else if (width != '') {
            size = width;
        } else if (height != '') {
            size = height;
        }

        var form_data = new FormData();
        form_data.append('url', url);
        form_data.append('action', 'holdySave');
        form_data.append('nonce', nonce);
        form_data.append('name', size + '.' + format);

        $.ajax({
            url: ajaxUrl,
            type: 'POST',
            contentType: false,
            processData: false,
            cache: false,
            data: form_data,
            success: function () {
                btn.html(btn.attr('data-saved'));
                setTimeout(function(){
                    btn.html(btn.attr('data-text'));
                }, 2000); 
            },
            error: function(jqXHR,error, errorThrown) {
                if(jqXHR.status&&jqXHR.status==400){
                    alert(jqXHR.responseText);
                }else{
                    alert('Something went wrong.');
                }
                btn.html(btn.attr('data-text'));
            }
        }).done(function() {
            btn.css('pointer-events', 'auto');
        });
    }); 
} )( jQuery );